-- Program by Morlis to learn Lua and create wow addons, with the help of various online tutorials.

local ExpMessage = CreateFrame("Frame")
ExpMessage:RegisterEvent("PLAYER_LOGIN")
ExpMessage:RegisterEvent("PLAYER_ENTERING_WORLD")
ExpMessage:RegisterEvent("PLAYER_XP_UPDATE")
ExpMessage.xpold = UnitXP("player")

ExpMessage:SetScript("OnEvent", function(self, event, ...)
    local xp = UnitXP("player")
	local prevxp = self.xpold
	local perc = string.format("%.1f%%", (xp / UnitXPMax("player") * 100))

	local function trunc(num, digits)
		local mult = 10^(digits)
		return math.modf(num*mult)/mult
	end
	
	if ((xp - prevxp > 0) and (prevxp > 0)) then
		local expgain = (xp - prevxp)
		local expneed = (UnitXPMax("player") - xp)
		local timesneed = (trunc((UnitXPMax("player") - xp) / (xp - prevxp), 0) + 1)
		print("Exp gain: "..(expgain)..", Exp needed: "..(expneed)..", Currently at "..(perc).." Times: "..(timesneed))
	end
    self.xpold = xp
end)
